searchData={"items":[{"type":"module","title":"Minikv","doc":"","ref":"Minikv.html"},{"type":"module","title":"Minikv.Kv","doc":"","ref":"Minikv.Kv.html"},{"type":"type","title":"Minikv.Kv.lock/0","doc":"","ref":"Minikv.Kv.html#t:lock/0"},{"type":"type","title":"Minikv.Kv.t/0","doc":"","ref":"Minikv.Kv.html#t:t/0"},{"type":"module","title":"Minikv.Kvs","doc":"A supervisor for Minikv, providing a key-value store.","ref":"Minikv.Kvs.html"},{"type":"macro","title":"Minikv.Kvs.__using__/1","doc":"A macro to use the KVS in a module.","ref":"Minikv.Kvs.html#__using__/1"},{"type":"macro","title":"Example - Minikv.Kvs.__using__/1","doc":"defmodule MyExampleKvs do\n      use Minikv.Kvs\n    end","ref":"Minikv.Kvs.html#__using__/1-example"},{"type":"function","title":"Minikv.Kvs.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Minikv.Kvs.html#child_spec/1"},{"type":"function","title":"Minikv.Kvs.delete/2","doc":"Deletes a value from the KVS.","ref":"Minikv.Kvs.html#delete/2"},{"type":"function","title":"Example - Minikv.Kvs.delete/2","doc":"iex> Minikv.Kvs.delete(:my_kvs, \"my_key\")\n    :ok","ref":"Minikv.Kvs.html#delete/2-example"},{"type":"function","title":"Minikv.Kvs.get/2","doc":"Retrieves a value from the KVS.","ref":"Minikv.Kvs.html#get/2"},{"type":"function","title":"Example - Minikv.Kvs.get/2","doc":"iex> Minikv.Kvs.get(:my_kvs, \"my_key\")\n    %Kv{value: \"my_value\", node: :node1, time: 123456789}","ref":"Minikv.Kvs.html#get/2-example"},{"type":"function","title":"Minikv.Kvs.init/1","doc":"","ref":"Minikv.Kvs.html#init/1"},{"type":"function","title":"Minikv.Kvs.lock/2","doc":"Lock a key in the registry.","ref":"Minikv.Kvs.html#lock/2"},{"type":"function","title":"Example - Minikv.Kvs.lock/2","doc":"iex> {:ok, registry} = Minikv.Kvs.start_link(name: :my_registry)\n    iex> Minikv.Kvs.lock(registry, \"my_key\")\n    :ok","ref":"Minikv.Kvs.html#lock/2-example"},{"type":"function","title":"Minikv.Kvs.persist/2","doc":"Persist a key value in the registry.","ref":"Minikv.Kvs.html#persist/2"},{"type":"function","title":"Example - Minikv.Kvs.persist/2","doc":"iex> {:ok, registry} = Minikv.Kvs.start_link(name: :my_registry)\n    iex> Minikv.Kvs.delete(registry, \"my_key\")\n    :ok","ref":"Minikv.Kvs.html#persist/2-example"},{"type":"function","title":"Minikv.Kvs.put/3","doc":"Puts a value into the KVS.","ref":"Minikv.Kvs.html#put/3"},{"type":"function","title":"Example - Minikv.Kvs.put/3","doc":"iex> Minikv.Kvs.put(:my_kvs, \"my_key\", \"my_value\")\n    :ok","ref":"Minikv.Kvs.html#put/3-example"},{"type":"function","title":"Minikv.Kvs.set/3","doc":"Puts a value into the KVS.","ref":"Minikv.Kvs.html#set/3"},{"type":"function","title":"Example - Minikv.Kvs.set/3","doc":"iex> Minikv.Kvs.set(:my_kvs, \"my_key\", \"my_value\")\n    :ok","ref":"Minikv.Kvs.html#set/3-example"},{"type":"function","title":"Minikv.Kvs.start_link/1","doc":"","ref":"Minikv.Kvs.html#start_link/1"},{"type":"function","title":"Minikv.Kvs.unlock/2","doc":"Unlock a key in the registry.","ref":"Minikv.Kvs.html#unlock/2"},{"type":"function","title":"Example - Minikv.Kvs.unlock/2","doc":"iex> {:ok, registry} = Minikv.Kvs.start_link(name: :my_registry)\n    iex> Minikv.Kvs.lock(registry, \"my_key\")\n    :ok\n    iex> Minikv.Kvs.unlock(registry, \"my_key\")\n    :ok","ref":"Minikv.Kvs.html#unlock/2-example"},{"type":"type","title":"Minikv.Kvs.kv/0","doc":"","ref":"Minikv.Kvs.html#t:kv/0"},{"type":"type","title":"Minikv.Kvs.result/0","doc":"","ref":"Minikv.Kvs.html#t:result/0"},{"type":"module","title":"Minikv.Registry","doc":"A registry for Minikv, providing a distributed key-value store.","ref":"Minikv.Registry.html"},{"type":"function","title":"Minikv.Registry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Minikv.Registry.html#child_spec/1"},{"type":"function","title":"Minikv.Registry.delete/2","doc":"Deletes a value from the registry.","ref":"Minikv.Registry.html#delete/2"},{"type":"function","title":"Example - Minikv.Registry.delete/2","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.delete(registry, \"my_key\")\n    :ok","ref":"Minikv.Registry.html#delete/2-example"},{"type":"function","title":"Minikv.Registry.get/2","doc":"Retrieves a value from the registry.","ref":"Minikv.Registry.html#get/2"},{"type":"function","title":"Example - Minikv.Registry.get/2","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.get(registry, \"my_key\")\n    %Minikv.Kv{value: \"my_value\", node: :node1, time: 123456789}","ref":"Minikv.Registry.html#get/2-example"},{"type":"function","title":"Minikv.Registry.init/1","doc":"","ref":"Minikv.Registry.html#init/1"},{"type":"function","title":"Minikv.Registry.lock/2","doc":"Lock a key in the registry.","ref":"Minikv.Registry.html#lock/2"},{"type":"function","title":"Example - Minikv.Registry.lock/2","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.lock(registry, \"my_key\")\n    :ok","ref":"Minikv.Registry.html#lock/2-example"},{"type":"function","title":"Minikv.Registry.persist/2","doc":"Persist a key value in the registry.","ref":"Minikv.Registry.html#persist/2"},{"type":"function","title":"Example - Minikv.Registry.persist/2","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.delete(registry, \"my_key\")\n    :ok","ref":"Minikv.Registry.html#persist/2-example"},{"type":"function","title":"Minikv.Registry.put/3","doc":"Puts a value into the registry.","ref":"Minikv.Registry.html#put/3"},{"type":"function","title":"Example - Minikv.Registry.put/3","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.put(registry, \"my_key\", \"my_value\")\n    :ok","ref":"Minikv.Registry.html#put/3-example"},{"type":"function","title":"Minikv.Registry.start_link/1","doc":"","ref":"Minikv.Registry.html#start_link/1"},{"type":"function","title":"Minikv.Registry.unlock/2","doc":"Unlock a key in the registry.","ref":"Minikv.Registry.html#unlock/2"},{"type":"function","title":"Example - Minikv.Registry.unlock/2","doc":"iex> {:ok, registry} = Minikv.Registry.start_link(name: :my_registry)\n    iex> Minikv.Registry.lock(registry, \"my_key\")\n    :ok\n    iex> Minikv.Registry.unlock(registry, \"my_key\")\n    :ok","ref":"Minikv.Registry.html#unlock/2-example"},{"type":"type","title":"Minikv.Registry.kv/0","doc":"","ref":"Minikv.Registry.html#t:kv/0"},{"type":"type","title":"Minikv.Registry.lock/0","doc":"","ref":"Minikv.Registry.html#t:lock/0"},{"type":"type","title":"Minikv.Registry.result/0","doc":"","ref":"Minikv.Registry.html#t:result/0"},{"type":"extras","title":"Minikv","doc":"Minikv\n=======\n[![Build Status](https://github.com/yassinrais/minikv/workflows/minikv/badge.svg)](https://github.com/yassinrais/minikv/actions)\n[![Last Updated](https://img.shields.io/github/last-commit/yassinrais/minikv.svg)](https://github.com/yassinrais/minikv/commits/master)\n[![MIT License](https://img.shields.io/github/license/yassinrais/minikv)](https://github.com/yassinrais/minikv/blob/main/LICENSE)\n[![Coveralls](https://coveralls.io/repos/yassinrais/minikv/badge.svg?branch=main)](https://coveralls.io/r/yassinrais/minikv?branch=master)\n\nMinikv: A lightweight Elixir library for building distributed key-value stores (:ets) featuring asynchronous replication between nodes,\noffering a simple way to store and retrieve key-value pairs, with advanced features like key expiration, locking, and persistence.\n\nInstallation\n------------\n\nTo use Minikv in your Elixir project, add it as a dependency in your `mix.exs` file:\n\n```elixir\ndefp deps do\n  [\n    {:minikv, \"~> 0.1.1\"}\n  ]\nend\n```\n\n\nThen run `mix deps.get` to fetch the dependency.\n\nExample Usage\n-----","ref":"readme.html"},{"type":"extras","title":"Storing a value - Minikv","doc":"To store a value in the registry, you can use the `Minikv.Registry.put/3` function:\n\n```elixir\niex> Minikv.Registry.put(WalletExKv, :my_balance, \"100$\")\n%Minikv.Kv{value: \"100$\"}\n```","ref":"readme.html#storing-a-value"},{"type":"extras","title":"Retrieving a value - Minikv","doc":"To retrieve a value from the registry, you can use the `Minikv.Registry.get/2` function:\n\n```elixir\niex> Minikv.Registry.get(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\", node: :node1, time: 123456789}\n```","ref":"readme.html#retrieving-a-value"},{"type":"extras","title":"Deleting a value - Minikv","doc":"To delete a value from the registry, you can use the `Minikv.Registry.delete/2` function:\n\n```elixir\niex> Minikv.Registry.delete(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\"}\n```","ref":"readme.html#deleting-a-value"},{"type":"extras","title":"Locking a key - Minikv","doc":"Minikv allows you to lock a key in the registry, preventing other nodes from modifying it. To lock a key, you can use the `Minikv.Registry.lock/2` function:\n\n```elixir\niex> Minikv.Registry.lock(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\", lock: true}\n```","ref":"readme.html#locking-a-key"},{"type":"extras","title":"Unlocking a key - Minikv","doc":"To unlock a key in the registry, you can use the `Minikv.Registry.unlock/2` function:\n\n```elixir\niex> Minikv.Registry.unlock(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\", lock: nil}\n```","ref":"readme.html#unlocking-a-key"},{"type":"extras","title":"Persisting a key-value - Minikv","doc":"To persist a key-value in the registry, you can use the `Minikv.Registry.persist/2` function:\n\n```elixir\niex> Minikv.Registry.persist(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\", exp: nil}\n```\n\nAdvanced Usage\n--------------","ref":"readme.html#persisting-a-key-value"},{"type":"extras","title":"Customizing key-value options - Minikv","doc":"When storing a value in the registry, you can customize the options associated with the key-value pair. The `Minikv.Registry.put/3` function accepts a list of options as the third argument:\n\n```elixir\niex> Minikv.Registry.put(WalletExKv, :my_balance, [value: \"100$\", ttl: 1000])\n%Minikv.Kv{value: \"100$\", exp: 123_456_789_100}\n```\n\nIn the above example, we've set the `ttl` (time-to-live) of the key-value pair to 1000 milliseconds. Other available options include:\n\n* `:lock` - A boolean value indicating whether the key should be locked.\n* `:persist` - A boolean value indicating whether the key-value should be persisted.","ref":"readme.html#customizing-key-value-options"},{"type":"extras","title":"Handling errors - Minikv","doc":"The functions provided by Minikv can return errors in certain situations. For example, if you try to retrieve a value for a key that doesn't exist, the `Minikv.Registry.get/2` function will return `nil`.\n\n```elixir\niex> Minikv.Registry.get(WalletExKv, :nonexistent_key)\nnil\n```\n\nSimilarly, if you try to lock a key that's already locked by another process, the `Minikv.Registry.lock/2` function will return `{:error, :locked}`.\n\n```elixir\niex> Minikv.Registry.lock(WalletExKv, :my_balance)\n%Minikv.Kv{value: \"100$\", lock: true}\niex> Minikv.Registry.lock(WalletExKv, :my_balance)\n{:error, :locked}\n```","ref":"readme.html#handling-errors"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}